#!/bin/sh

: ${SECS:=100}

SAVEPATH=$PATH
MASTERPATH=$HOME/pg_head/root/HEAD/inst/bin
FDPATH=$HOME/pg_fast_def/root/HEAD/inst/bin

setup () {
    dropdb --if-exists test
    createdb test
    psql -f setup.sql -q test > /dev/null
}

run_test () {
    for f in query*.sql
    do 
	echo =======
	echo $f
	cat $f
	pgbench -n -T $SECS -f $f test | egrep -v 'number|latency|scaling|tps.*excluding|simple|transaction|duration' | sed -e 's/(including.*//' 
    done
}

PATH=$MASTERPATH:$SAVEPATH setup
PATH=$FDPATH:$SAVEPATH setup

export PATH=$MASTERPATH:$SAVEPATH
run_test > master.log 

export PATH=$FDPATH:$SAVEPATH
run_test > fd.log 

echo 'create table nt as select * from t; drop table t; drop table t_dropped; alter table nt rename to t; create table t_dropped as select * from t; alter table t_dropped drop column c900;'  | psql -q test

run_test > fdnm.log 

diff -u master.log fd.log | sed -e 1,3d -e 's/+tps/ fastdef tps/' -e 's/-tps/ master  tps/' -e 's/.//' > results1.txt
diff -u results1.txt  fdnm.log | sed -e 1,3d -e 's/+tps/ fdnmiss tps/' -e 's/.//' > results.txt

